<?php
defined('BASEPATH') OR exit('No direct script access allowed');

/*
| -------------------------------------------------------------------------
| URI ROUTING
| -------------------------------------------------------------------------
| This file lets you re-map URI requests to specific controller functions.
|
| Typically there is a one-to-one relationship between a URL string
| and its corresponding controller class/method. The segments in a
| URL normally follow this pattern:
|
|	example.com/class/method/id/
|
| In some instances, however, you may want to remap this relationship
| so that a different class/function is called than the one
| corresponding to the URL.
|
| Please see the user guide for complete details:
|
|	https://codeigniter.com/user_guide/general/routing.html
|
| -------------------------------------------------------------------------
| RESERVED ROUTES
| -------------------------------------------------------------------------
|
| There are three reserved routes:
|
|	$route['default_controller'] = 'welcome';
|
| This route indicates which controller class should be loaded if the
| URI contains no data. In the above example, the "welcome" class
| would be loaded.
|
|	$route['404_override'] = 'errors/page_missing';
|
| This route will tell the Router which controller/method to use if those
| provided in the URL cannot be matched to a valid route.
|
|	$route['translate_uri_dashes'] = FALSE;
|
| This is not exactly a route, but allows you to automatically route
| controller and method names that contain dashes. '-' isn't a valid
| class or method name character, so it requires translation.
| When you set this option to TRUE, it will replace ALL dashes in the
| controller and method URI segments.
|
| Examples:	my-controller/index	-> my_controller/index
|		my-controller/my-method	-> my_controller/my_method
*/

$route['translate_uri_dashes'] = FALSE;

$route['default_controller'] = "systemid";
$route['404_override'] = 'systemid/error404';

$route['category/trash/clearall/now'] = 'systemid/index/trash/clearall/now';
$route['category/(:any)'] = 'systemid/index/$1';

// Add, edit and delete category
$route['category/(:any)/delete/(:num)'] = 'systemid/index/$1/delete/$2';
$route['category/(:any)/deleteitem/(:num)'] = 'systemid/index/$1/deleteitem/$2';
$route['categoryedit/(:num)'] = 'systemid/categoryedit/$1';
$route['categoryadd'] = 'systemid/categoryadd';

// Add, edit, and delete ToDos
$route['todoedit/(:num)/(:num)'] = 'systemid/todoedit/$1/$2';
$route['todoadd/(:num)'] = 'systemid/todoadd/$1';

$route['components'] = 'systemid/usedcomponents';
$route['about'] = 'systemid/about';

$route['login'] = 'systemid/index';
$route['logout'] = 'systemid/logout';
$route['change-password'] = 'systemid/changepassword';
$route['register'] = 'systemid/register';
$route['settings'] = 'systemid/settingsofscript';
$route['edit-email'] = 'systemid/editemail';
$route['logs/(:num)'] = 'systemid/showlogs/$1';
$route['logs'] = 'systemid/showlogs';
$route['users/(:num)'] = 'systemid/showusers/$1';
$route['users'] = 'systemid/showusers';
$route['userdetails/(:num)'] = 'systemid/showuserdetails/$1';
$route['activate/(:num)/(:any)'] = 'systemid/activateaccount/$1/$2';
$route['password'] = 'systemid/getpassword';
$route['generate-password/(:num)/(:any)/(:any)'] = 'systemid/postpassword/$1/$2/$3';

?>