<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

/**
 * @author: Lucas Sosna
 * @copyright: 2019
 * @e-mail: tree@interia.pl
 * @e-mail: support@phpbluedragon.eu
 * @www: http://phpbluedragon.eu
 */

use PHPMailer\PHPMailer\PHPMailer;
use PHPMailer\PHPMailer\Exception;
use PHPMailer\PHPMailer\SMTP;

class Systemid extends CI_Controller
{
    /*
     * Change PHPMailer from version 5 to version 6
     *
     *
     * ToDo:
     *
     * X - login
     * X - Logout
     *
     *  X - add category
     *  X - delete category
     *  X - edit category
     *
     *  X - add todo
     *  X - edit todo
     *  X - delete todo
     * - view todo
     * X - clear trash
     * X - trash - edit/add to todos
     *
     * X - register
     * X - e-mail register
     * X - forgot password
     * X - e-mail password
     * X - open page from email
     * X - change password
     *
     * X - page settings
     * X - e-mails edit
     * X - logs
     * X - users
     * X - detail of user account - with change some data
     *
     * X - about
     * X - components
     *
     * Extra Used
     * https://fengyuanchen.github.io/datepicker/
     *
     * Nowa wersja FontAwesome
     *
     */
    public function __construct()
    {
        parent::__construct();
        
        $this->load->model('System_model');
        $this->load->library('form_validation');
        
        $this->output->enable_profiler(false);
        
        $this->lang->load('system', $this->config->item('language'));
    }

    // WORKING
    public function index($CategoryId='',$Action='',$SubAction="")
    {
    	/*echo '<pre>';
    	for($i=100;$i<502;$i++)
	    {
	    	echo '$lang[\'c'.$i.'\'] = \'\';'."\n";
	    }
    	echo '</pre>';*/

        if($_SESSION['user_id'] == "")
        {            
			// Login form

            if($this->input->post('formlogin') == 'yes')
            {
                $this->form_validation->set_rules('user_email', ''.$this->lang->line('a0860').'', 'required|valid_email');
                $this->form_validation->set_rules('user_password', ''.$this->lang->line('a0861').'', 'required');

                if($this->form_validation->run() != FALSE)
                {
                    $TableUser = $this->System_model->CheckUser();

                    //$MyNoiseQuery = $this->System_model->ChangePasswordAutomat(1,'MyTempPassword');

                    if($TableUser['IsAuth'] == 'no')
                    {
                        $SystemLang['bad_data'] = true;
                        $this->System_model->WriteLog($this->lang->line('c100').' '.$this->input->post('user_email'));
                    }

                    if($TableUser['IsAuth'] == 'noactiveaccount')
			        {
				        $SystemLang['account_not_active'] = true;
				        $this->System_model->WriteLog($this->lang->line('c101').' '.$this->input->post('user_email'));
			        }

                    if($TableUser['IsAuth'] == 'yes')
                    {
	                    $this->System_model->WriteLog($this->lang->line('c102').' '.$TableUser['UserEmail']);

                        $_SESSION['user_id'] = $TableUser['UserId'];
                        $_SESSION['user_email'] = $TableUser['UserEmail'];
                        $_SESSION['user_admin'] = $TableUser['UserAdmin'];
                        $_SESSION['CatpchaWord'] = '';
                        redirect();
                    }
                }
            }

            $SystemLang['Title'] = ''.$this->lang->line('a0862').'';
            //$SystemLang['Content'] = ''.$this->lang->line('a0863').'';
                       
            $this->load->view('head',$SystemLang);
            
            $this->load->view('login', $SystemLang);
            
            $this->load->view('foot');
        }
        else
        {
            $SystemLang['Title'] = $this->lang->line('a1190');
            
            $this->load->view('head',$SystemLang);

            // Delete category
            if($Action == 'delete')
            {
	            $this->System_model->WriteLog($this->lang->line('c103'));

                $this->System_model->CategoryDelete($SubAction);

                $SystemLang['CategoryWasDeleted'] = true;
            }

            // Delete item from category
	        if($Action == 'deleteitem')
	        {
		        $this->System_model->WriteLog($this->lang->line('c104'));

		        $this->System_model->ToDoDeleteItem($SubAction);

		        $SystemLang['ToDoWasDeletedItem'] = true;
	        }

	        // Clear trash
	        if($Action == 'clearall' AND $SubAction == 'now')
	        {
		        $this->System_model->WriteLog($this->lang->line('c105'));

		        $this->System_model->ToDoDeleteTrash();

		        $SystemLang['ToDoWasDeletedTrash'] = true;
	        }

            // Menu generation
            $SystemLang['GeneratedMenu'] = '<a href="'.base_url('category/myday').'" class="btn btn-info btn-block"><span class="fas fa-calendar-day"></span> '.$this->lang->line('c106').'</a>';
            $SystemLang['GeneratedMenu'] .= '<a href="'.base_url('category/important').'" class="btn btn-info btn-block"><span class="fas fa-exclamation-circle"></span> '.$this->lang->line('c107').'</a>';
            $SystemLang['GeneratedMenu'] .= '<a href="'.base_url('category/planned').'" class="btn btn-info btn-block"><span class="fas fa-paper-plane"></span> '.$this->lang->line('c108').'</a>';
            $SystemLang['GeneratedMenu'] .= '<a href="'.base_url('category/tasks').'" class="btn btn-info btn-block"><span class="fas fa-tasks"></span> '.$this->lang->line('c109').'</a>';
            $SystemLang['GeneratedMenu'] .= '<a href="'.base_url('category/trash').'" class="btn btn-info btn-block"><span class="fas fa-trash-alt"></span> '.$this->lang->line('c110').'</a>';

            $SystemLang['GeneratedMenu'] .= '<br />';
            $SystemLang['GeneratedMenu'] .= '<a href="'.base_url('categoryadd').'" class="btn btn-warning btn-block"><span class="fas fa-pen-nib"></span> '.$this->lang->line('c111').'</a>';
            $SystemLang['GeneratedMenu'] .= '<br />';

            $ResultDB = $this->System_model->SelectCategoryList();

            foreach($ResultDB->result() as $row)
            {
                $SystemLang['GeneratedMenu'] .= '<a href="'.base_url('category/'.$row->category_id).'" class="btn btn-info btn-block"><span class="fa fa-cog"></span> '.$row->category_name.'</a>';

                /*$SystemLang['GeneratedMenu'] .= '<div class="btn-group" role="group">
                  <a class="btn btn-block btn-info ">Left</a>
                  <a class="btn btn-secondary">[E]</a>
                  <a class="btn btn-secondary">[D]</a>
                </div>';*/
            }

            // Contant generatorion
            /*
            * 1 - My Day
            * 2 - Important
            * 3 - Planned
            * 4 - Tasks
            * 5 - Trash
            */

            $CatIdIs = null;

            if($CategoryId == "" OR $CategoryId == 'myday') { $CatIdIs = 1; $CatNameIs = 'myday'; $SystemLang['Title'] = $this->lang->line('c112').$this->lang->line('c106'); $SystemLang['TitleCategory'] = $SystemLang['Title']; }
            elseif($CategoryId == 'important') { $CatIdIs = 2; $CatNameIs = 'important'; $SystemLang['Title'] = $this->lang->line('c112').$this->lang->line('c107'); $SystemLang['TitleCategory'] = $SystemLang['Title']; }
            elseif($CategoryId == 'planned') { $CatIdIs = 3; $CatNameIs = 'planned'; $SystemLang['Title'] = $this->lang->line('c112').$this->lang->line('c108'); $SystemLang['TitleCategory'] = $SystemLang['Title']; }
            elseif($CategoryId == 'tasks') { $CatIdIs = 4; $CatNameIs = 'tasks'; $SystemLang['Title'] = $this->lang->line('c112').$this->lang->line('c109'); $SystemLang['TitleCategory'] = $SystemLang['Title']; }
            elseif($CategoryId == 'trash') { $CatIdIs = 5; $CatNameIs = 'trash'; $SystemLang['Title'] = $this->lang->line('c112').$this->lang->line('c110'); $SystemLang['TitleCategory'] = $SystemLang['Title']; }
            else {
                if(is_numeric($CategoryId))
                {
                    $CatIdIs = $CategoryId;
	                $CatNameIs = 'FromDB';

                    $ResultDB = $this->System_model->SelectOneCategoryById($CategoryId);

                    foreach($ResultDB->result() as $row)
                    {
                        $SystemLang['Title'] = $this->lang->line('c112').$row->category_name;
                        $SystemLang['TitleCategory'] = $SystemLang['Title'];
                    }
                }
                else
                {
                    exit();
                }
            }

            $SystemLang['CatNameIs'] = $CatNameIs;

            if($CatIdIs == null)
            {
                exit();
            }

	        $SystemLang['AddNewToDoButton'] .= '<div class="row">';

		        $SystemLang['AddNewToDoButton'] .= '<div class="col-md-8">';

		        if($CatNameIs == 'FromDB') {
			        $SystemLang['AddNewToDoButton'] .= ' <a href="' . base_url('categoryedit/' . $row->category_id) . '" class="btn btn-info"><span class="fas fa-pencil-alt"></span> '.$this->lang->line('c113').'</a>' .
				        ' <a href="JavaScript:DeteleInfo(\'' . base_url() . 'category/myday/delete/' . $row->category_id . '\',\'' . $this->lang->line('a1047') . '\');" class="btn btn-info"><span class="fas fa-cut"></span> '.$this->lang->line('c114').'</a>';
		        }

	            $SystemLang['AddNewToDoButton'] .= '</div>';

	            $SystemLang['AddNewToDoButton'] .= '<div class="col-md-4">';

	            if($CatIdIs == 5)
	            {
	                $SystemLang['AddNewToDoButton'] .= '<a href="JavaScript:DeteleInfo(\'' . base_url('category/trash/clearall/now') . '\',\''.$this->lang->line('c115').'\');" class="btn btn-danger btn-block"><span class="fas fa-trash"></span> '.$this->lang->line('c116').'</a>';
	            }
	            else
	            {
		            $SystemLang['AddNewToDoButton'] .= '<a href="'.base_url('todoadd/'.$CatIdIs).'" class="btn btn-info btn-block"><span class="fas fa-file-alt"></span> '.$this->lang->line('c117').'</a>';
	            }

		        $SystemLang['AddNewToDoButton'] .= '</div>';

			$SystemLang['AddNewToDoButton'] .= '</div>';

	        $SystemLang['AddNewToDoButton'] .= '<div class="clear"><br /></div>';

            //$SystemLang['GenerateContent']
            $ResultDBToDos = $this->System_model->SelectCategoryContent($CatIdIs);

            /*echo '<pre>';
            print_r($ResultDBToDos->result());
            echo '</pre>';*/

            $SystemLang['GenerateContent'] = null;

            $RowColor = 0;

	        $SystemLang['GenerateContent'] .= '<div class="border border-primary rounded">';


            foreach($ResultDBToDos->result() as $row)
            {
                $IsContent = true;

	            if($CatNameIs == 'FromDB')
	            {
		            $CatNameInUrl = $CatIdIs;
	            }
	            else
	            {
		            $CatNameInUrl = $CatNameIs;
	            }

	            if($RowColor == 1)
	            {
	            	$BgColorClass = 'bg-light';
	            	$RowColor = 0;
	            }
	            else
	            {
		            //$BgColorClass = 'bg-secondary';
		            $BgColorClass = '';
		            $RowColor = 1;
	            }

	            if($CatIdIs == 3)
	            {
		            $SystemLang['GenerateContent'] .= '<div class="row '.$BgColorClass.'" style="margin: 5px; margin-top: 10px; margin-bottom: 10px;">
                  <div class="col-md-7">' . substr($row->todo_desc, 0, 300) . '...</div>
                  <div class="col-md-2">'.$row->todo_planned_date.'</div>
                  <div class="col-md-3"><a href="'.base_url('todoedit/'.$CatIdIs.'/'.$row->todo_id).'" class="btn btn-info btn-sm"><span class="far fa-file-code"></span> '.$this->lang->line('c118').'</a> 
                  <a href="JavaScript:DeteleInfo(\''.base_url().'category/'.$CatNameInUrl.'/deleteitem/'.$row->todo_id.'\',\''.$this->lang->line('a1047').'\');" class="btn btn-info btn-sm"><span class="far fa-bell-slash"></span> '.$this->lang->line('c119').'</a></div>
                  </div>';
	            }
	            elseif($CatIdIs == 5)
	            {
		            $SystemLang['GenerateContent'] .= '<div class="row '.$BgColorClass.'" style="margin: 5px; margin-top: 10px; margin-bottom: 10px;">
                  <div class="col-md-10">' . substr($row->todo_desc, 0, 300) . '...</div>
                  <div class="col-md-2"><a href="'.base_url('todoedit/'.$CatIdIs.'/'.$row->todo_id).'" class="btn btn-info btn-sm"><span class="far fa-file-code"></span> '.$this->lang->line('c118').'</a> 
                  </div>
                  </div>';
	            }
	            elseif($CatIdIs != 5)
	            {
	            	$SystemLang['GenerateContent'] .= '<div class="row '.$BgColorClass.'" style="margin: 5px; margin-top: 10px; margin-bottom: 10px;">
                  <div class="col-md-9">' . substr($row->todo_desc, 0, 300) . '...</div>
                  <div class="col-md-3"><a href="'.base_url('todoedit/'.$CatIdIs.'/'.$row->todo_id).'" class="btn btn-info btn-sm"><span class="far fa-file-code"></span> '.$this->lang->line('c118').'</a> 
                  <a href="JavaScript:DeteleInfo(\''.base_url().'category/'.$CatNameInUrl.'/deleteitem/'.$row->todo_id.'\',\''.$this->lang->line('a1047').'\');" class="btn btn-info btn-sm"><span class="far fa-bell-slash"></span> '.$this->lang->line('c119').'</a></div>
                  </div>';
	            }
	            else
	            {
		            $SystemLang['GenerateContent'] .= '<div class="row '.$BgColorClass.'" style="margin: 5px; margin-top: 10px; margin-bottom: 10px;">
                  <div class="col-md-12">' . substr($row->todo_desc, 0, 300) . '...</div>
                  </div>';
	            }
            }

            if($IsContent == false)
            {
                $SystemLang['GenerateContent'] .= '<div class="row" style="margin: 5px; margin-top: 10px; margin-bottom: 10px; text-align: center;">
                  <div class="col-md-12">'.$this->lang->line('c120').'</div>
                  </div>';
            }
	        $SystemLang['GenerateContent'] .= '</div>';

            $this->load->view('todomain', $SystemLang);
            
            $this->load->view('foot');
        }
    }

    // WORKING
    public function categoryedit($CategoryId='')
    {
        if($_SESSION['user_id'] == ""){redirect();exit();}

        $SystemLang['CategoryId'] = $CategoryId;

        if($this->input->post('formwassend') == 'yes')
        {
            $this->form_validation->set_rules('category_name', '' . $this->lang->line('a1134') . '', 'required');

            if ($this->form_validation->run() != FALSE)
            {
	            $this->System_model->WriteLog($this->lang->line('c121'));
                $this->System_model->CategoryEdit($CategoryId,$this->input->post('category_name'));
                $SystemLang['UpdateCategorySuccess'] = true;
            }

            $SystemLang['Vcategory_name'] = $this->input->post('category_name');
        }

        $ResultDBToDos = $this->System_model->SelectOneCategoryById($CategoryId);

        foreach($ResultDBToDos->result() as $row)
        {
            $SystemLang['CategoryName'] = $row->category_name;
            if($this->input->post('formwassend') != 'yes') {
                $SystemLang['Vcategory_name'] = $row->category_name;
            }
        }

        $SystemLang['Title'] = $this->lang->line('c123');
        $SystemLang['Content'] = $this->lang->line('c123');

        $this->load->view('head',$SystemLang);

        $this->load->view('category/edit', $SystemLang);

        $this->load->view('foot');
    }

    // WORKING
    public function categoryadd()
    {
        if($_SESSION['user_id'] == ""){redirect();exit();}

        if($this->input->post('formwassend') == 'yes')
        {
            $this->form_validation->set_rules('category_name', '' . $this->lang->line('a1134') . '', 'required');

            if ($this->form_validation->run() != FALSE)
            {
	            $this->System_model->WriteLog($this->lang->line('c124'));
                $this->System_model->CategoryAdd($this->input->post('category_name'));
                $SystemLang['UpdateCategorySuccess'] = true;
            }

            $SystemLang['Vcategory_name'] = '';
        }

        $SystemLang['Title'] = $this->lang->line('c125');
        $SystemLang['Content'] = $this->lang->line('c126');

        $this->load->view('head',$SystemLang);

        $this->load->view('category/add', $SystemLang);

        $this->load->view('foot');
    }

    // WORKING
    public function todoadd($CategoryId)
    {
	    if($_SESSION['user_id'] == ""){redirect();exit();}

	    // Kategorie
	    //$SystemLang['OptionsList']['1'] = 'My Day';
	    //$SystemLang['OptionsList']['2'] = 'Important';
	    //$SystemLang['OptionsList']['3'] = 'Planned';
	    $SystemLang['OptionsList']['4'] = $this->lang->line('c109');
	    //$SystemLang['OptionsList']['5'] = 'Trash';

	    $ResultDB = $this->System_model->SelectCategoryList();

	    foreach($ResultDB->result() as $row) {
		    $SystemLang['OptionsList'][$row->category_id] = $row->category_name;
	    }

	    $SystemLang['CategoryIdNum'] = $CategoryId;

	    if($CategoryId == "" OR $CategoryId == '1') { $SystemLang['CategoryId'] = 'myday'; $SystemLang['CategoryName'] = $this->lang->line('c106'); }
	    elseif($CategoryId == '2') { $SystemLang['CategoryId'] = 'important'; $SystemLang['CategoryName'] = $this->lang->line('c107'); }
	    elseif($CategoryId == '3') { $SystemLang['CategoryId'] = 'planned'; $SystemLang['CategoryName'] = $this->lang->line('c108'); }
	    elseif($CategoryId == '4') { $SystemLang['CategoryId'] = 'tasks'; $SystemLang['CategoryName'] = $this->lang->line('c109'); }
	    //elseif($CategoryId == '5') { $SystemLang['CategoryId'] = 'trash'; $SystemLang['CategoryName'] = 'Trash'; }
	    else {
		    $SystemLang['CategoryId'] = $CategoryId;

		    $ResultDBToDos = $this->System_model->SelectOneCategoryById($CategoryId);

		    foreach ($ResultDBToDos->result() as $row) {
			    $SystemLang['CategoryId'] = $row->category_id;
			    $SystemLang['CategoryName'] = $row->category_name;
		    }
	    }

	    if($this->input->post('formwassend') == 'yes')
	    {
		    $this->form_validation->set_rules('todo_desc', $this->lang->line('c127'), 'required');

		    if ($this->form_validation->run() != FALSE)
		    {
			    $this->System_model->WriteLog($this->lang->line('c128'));
			    $this->System_model->ToDoAdd();

			    $SystemLang['Vtodo_desc'] = '';
			    $SystemLang['Vtodo_planned'] = '';
			    $SystemLang['Vtodo_planned_date'] = '';
			    $SystemLang['Vtodo_important'] = '';
			    $SystemLang['Vtodo_category'] = '';

			    $SystemLang['AddedToDoSuccess'] = true;
		    }
		    else
		    {
			    $SystemLang['Vtodo_desc'] = $this->input->post('todo_desc');
			    $SystemLang['Vtodo_planned'] = $this->input->post('todo_planned');
			    $SystemLang['Vtodo_planned_date'] = $this->input->post('todo_planned_date');
			    $SystemLang['Vtodo_important'] = $this->input->post('todo_important');
			    $SystemLang['Vtodo_category'] = $this->input->post('todo_category');
		    }
	    }

	    if($SystemLang['Vtodo_category'] == "") {
		    $SystemLang['Vtodo_category'] = $CategoryId;
	    }

	    $SystemLang['Title'] = $this->lang->line('c129');
	    $SystemLang['Content'] = $this->lang->line('c130');

	    $this->load->view('head',$SystemLang);

	    $this->load->view('todo/add', $SystemLang);

	    $this->load->view('foot');
    }

    // WORKING
	public function todoedit($CategoryId,$ItemId)
	{
		if($_SESSION['user_id'] == ""){redirect();exit();}

		// Kategorie
		//$SystemLang['OptionsList']['1'] = 'My Day';
		//$SystemLang['OptionsList']['2'] = 'Important';
		//$SystemLang['OptionsList']['3'] = 'Planned';
		$SystemLang['OptionsList']['4'] = $this->lang->line('c109');
		//$SystemLang['OptionsList']['5'] = 'Trash';

		$ResultDB = $this->System_model->SelectCategoryList();

		foreach($ResultDB->result() as $row) {
			$SystemLang['OptionsList'][$row->category_id] = $row->category_name;
		}

		$SystemLang['CategoryIdNum'] = $CategoryId;
		$SystemLang['ItemIdNum'] = $ItemId;

		if($CategoryId == "" OR $CategoryId == '1') { $SystemLang['CategoryId'] = 'myday'; $SystemLang['CategoryName'] = $this->lang->line('c106'); }
		elseif($CategoryId == '2') { $SystemLang['CategoryId'] = 'important'; $SystemLang['CategoryName'] = $this->lang->line('c107'); }
		elseif($CategoryId == '3') { $SystemLang['CategoryId'] = 'planned'; $SystemLang['CategoryName'] = $this->lang->line('c108'); }
		elseif($CategoryId == '4') { $SystemLang['CategoryId'] = 'tasks'; $SystemLang['CategoryName'] = $this->lang->line('c109'); }
		elseif($CategoryId == '5') { $SystemLang['CategoryId'] = 'trash'; $SystemLang['CategoryName'] = $this->lang->line('c110'); }
		else {
			$SystemLang['CategoryId'] = $CategoryId;

			$ResultDBToDos = $this->System_model->SelectOneCategoryById($CategoryId);

			foreach ($ResultDBToDos->result() as $row) {
				$SystemLang['CategoryId'] = $row->category_id;
				$SystemLang['CategoryName'] = $row->category_name;
			}
		}

		if($this->input->post('formwassend') == 'yes')
		{
			$this->form_validation->set_rules('todo_desc', $this->lang->line('c127'), 'required');

			if ($this->form_validation->run() != FALSE)
			{
				$this->System_model->WriteLog($this->lang->line('c131'));
				$this->System_model->ToDoEdit($ItemId);

				$SystemLang['UpdatedToDoSuccess'] = true;
			}

				$SystemLang['Vtodo_desc'] = $this->input->post('todo_desc');
				$SystemLang['Vtodo_planned'] = $this->input->post('todo_planned');
				$SystemLang['Vtodo_planned_date'] = $this->input->post('todo_planned_date');
				$SystemLang['Vtodo_important'] = $this->input->post('todo_important');
				$SystemLang['Vtodo_category'] = $this->input->post('todo_category');
		}
		else
		{

			$ResultDBToDos = $this->System_model->SelectOneToDoById($ItemId);

			foreach ($ResultDBToDos->result() as $row)
			{
				$SystemLang['Vtodo_desc'] = $row->todo_desc;
				$SystemLang['Vtodo_planned'] = $row->todo_planned;
				$SystemLang['Vtodo_planned_date'] = $row->todo_planned_date;
				$SystemLang['Vtodo_important'] = $row->todo_important;
				$SystemLang['Vtodo_category'] = $row->todo_category;
			}
		}

		if($SystemLang['Vtodo_category'] == "") {
			$SystemLang['Vtodo_category'] = $CategoryId;
		}

		$SystemLang['Title'] = $this->lang->line('c132');
		$SystemLang['Content'] = $this->lang->line('c133');

		$this->load->view('head',$SystemLang);

		$this->load->view('todo/edit', $SystemLang);

		$this->load->view('foot');
	}

    // WORKING
    public function getpassword()
    {
        $SystemLang['Title'] = ''.$this->lang->line('a0888').'';
        $SystemLang['Content'] = ''.$this->lang->line('a0889').'';

        $this->load->view('head',$SystemLang);

        if($this->input->post('formlogin') == 'yes')
        {
            $this->form_validation->set_rules('user_email', ''.$this->lang->line('a0890').'', 'required|valid_email|callback_is_this_email2');
            $this->form_validation->set_rules('user_captcha', ''.$this->lang->line('a0891').'', 'required|callback_is_valid_catpcha');

            if($this->form_validation->run() != FALSE)
            {
                $ResultDB = $this->System_model->UserCheckEmailSelect($this->input->post('user_email'));

                foreach($ResultDB->result() as $row)
                {
                    $UserId = $row->user_id;
                    $UserUsername = $row->user_email;
                    $UserAccountActive = $row->user_active;
                }

                if($UserAccountActive != 'y')
                {
	                $SystemLang['not_active'] = true;
	                $this->System_model->WriteLog($this->lang->line('c134').$this->input->post('user_email'));
                }
                elseif(empty($UserUsername))
                {
                    $SystemLang['bad_data'] = true;
	                $this->System_model->WriteLog($this->lang->line('c135').$this->input->post('user_email'));
                }
                else
                {
	                $this->System_model->WriteLog($this->lang->line('c136').$this->input->post('user_email'));

                    $SystemLang['pswd_send'] = true;

                    $this->load->helper('string');
                    $KeyPassword = random_string('alnum', 20);
                    $KeyPassword2 = random_string('alnum', 20);

                    $this->System_model->GenerateNewPassword($UserId,$KeyPassword,$KeyPassword2);

                    $ResultDB = $this->System_model->SelectGenerateNewPassword($UserId,$KeyPassword,$KeyPassword2);

                    foreach($ResultDB->result() as $row)
                    {
                        $UserDate = $row->password_time;
                        $UserIp = $row->password_ip;
                    }

                    $ResultDB = $this->System_model->SelectEmailContent('recpassword');

                    foreach($ResultDB->result() as $row)
                    {
                        $ReadyTitle = $row->email_title;
                        $ReadyContent = $row->email_content;
                    }

                    $PrepareMyLink = base_url().'generate-password/'.$UserId.'/'.$KeyPassword.'/'.$KeyPassword2;

                    $ReadyContent = str_replace('[change_password]',$PrepareMyLink,$ReadyContent);

                    $ReadyTitle = str_replace('[user_date]',$UserDate,$ReadyTitle);
                    $ReadyTitle = str_replace('[user_ip]',$UserIp,$ReadyTitle);

                    $ReadyContent = str_replace('[user_date]',$UserDate,$ReadyContent);
                    $ReadyContent = str_replace('[user_ip]',$UserIp,$ReadyContent);

                    $this->SendEmail($UserUsername,$ReadyTitle, $ReadyContent);
                }
            }
        }

        $this->load->helper('captcha');
        $this->load->helper('string');
        $SystemLang['RandomString'] = random_string('alnum', 6);

        $_SESSION['CatpchaWord'] = $SystemLang['RandomString'];

        $this->load->view('user/getpassword', $SystemLang);

        $this->load->view('foot');
    }

    // VALID
    public function is_this_email2($str)
    {
        $ResultDB = $this->System_model->UserCheckEmail($str);

        foreach($ResultDB->result() as $row)
        {
            $HowManyEmail = $row->HowMany;
        }

        if($HowManyEmail == 0)
        {
            $this->form_validation->set_message('is_this_email2', ''.$this->lang->line('a0884').'');
            return FALSE;
        }
        else
        {
            return TRUE;
        }
    }

    // VALID
    public function is_valid_catpcha($str)
    {
        if($_SESSION['CatpchaWord'] == $str)
        {
            return TRUE;
        }
        else
        {
            $this->form_validation->set_message('is_valid_catpcha', ''.$this->lang->line('a0885').'');
            return FALSE;
        }
    }

    // WORKING
    public function postpassword($UserId,$KeyPassword,$KeyPassword2)
    {
        $SystemLang['Title'] = ''.$this->lang->line('a0886').'';
        $SystemLang['Content'] = ''.$this->lang->line('a0887').'';

        $this->load->view('head',$SystemLang);

        $ResultDB = $this->System_model->CheckKeyPasswords($UserId,$KeyPassword,$KeyPassword2);

        foreach($ResultDB->result() as $row)
        {
            $HowManyIs = $row->HowMany;

            $SystemLang['change_password'] = false;

            if($HowManyIs > 0)
            {
	            $ResultDB2 = $this->System_model->GetUserDataById($UserId);
	            foreach($ResultDB2->result() as $row2)
	            {
		            $UserEmail = $row2->user_email;
	            }

	            $this->System_model->WriteLog($this->lang->line('c137').$UserEmail);

                $this->load->helper('string');
                $TemporaryPassword = random_string('alnum', 10);

                $this->System_model->ChangePasswordAutomat($UserId,$TemporaryPassword);

                $ResultDB4 = $this->System_model->SelectEmailContent('newpass');

                foreach($ResultDB4->result() as $row4)
                {
                    $ReadyTitle = $row4->email_title;
                    $ReadyContent = $row4->email_content;
                }

                $ResultDB5 = $this->System_model->GetUserDataById($UserId);

                foreach($ResultDB5->result() as $row5)
                {
	                $UserUsername = $row5->user_email;
                }

                $ReadyContent = str_replace('[new_password]',$TemporaryPassword,$ReadyContent);

                $DefUserDate = date('Y-m-d H:i:s');
                $DefUserIp = $_SERVER['REMOTE_ADDR'];

                $ReadyTitle = str_replace('[user_date]',$DefUserDate,$ReadyTitle);
                $ReadyTitle = str_replace('[user_ip]',$DefUserIp,$ReadyTitle);

                $ReadyContent = str_replace('[user_date]',$DefUserDate,$ReadyContent);
                $ReadyContent = str_replace('[user_ip]',$DefUserIp,$ReadyContent);

	            $this->SendEmail($UserUsername,$ReadyTitle, $ReadyContent);

                $SystemLang['change_password'] = true;

	            $this->System_model->WriteLog($this->lang->line('c138').$UserUsername);
            }
        }

        $this->load->view('user/postpassword', $SystemLang);

        $this->load->view('foot');
    }

    // WORKING
	public function changepassword()
	{
		if($_SESSION['user_id'] == ""){redirect();exit();}

		$SystemLang['Title'] = ''.$this->lang->line('a0896').'';
		$SystemLang['Content'] = ''.$this->lang->line('a0897').'';

		$this->load->view('head',$SystemLang);

		if($this->input->post('formchange') == 'yes')
		{
			$this->form_validation->set_rules('user_pswd', ''.$this->lang->line('a0898').'', 'required');
			$this->form_validation->set_rules('user_pswd2', ''.$this->lang->line('a0899').'', 'required|min_length[8]|max_length[20]');
			$this->form_validation->set_rules('user_pswd3', ''.$this->lang->line('a0900').'', 'required|min_length[8]|max_length[20]|callback_checkisthesame');

			if($this->form_validation->run() != FALSE)
			{
				$this->System_model->WriteLog($this->lang->line('c139'));
				$ResultDB = $this->System_model->UserGetData();

				$PasswordMatch = false;

				foreach($ResultDB->result() as $row)
				{
					if(password_verify($this->input->post('user_pswd'), $row->user_password) == false)
					{
						$PasswordMatch = true;
					}
				}

				if($PasswordMatch)
				{
					$SystemLang['PswdChangedError'] = true;
				}
				else
				{
					$this->System_model->UpdateUserPswd();
					$SystemLang['PswdChanged'] = true;
				}
			}
		}

		$this->load->view('user/changepassword', $SystemLang);

		$this->load->view('foot');
	}

	// WORKING - used in $this->changepassword()
	public function checkisthesame($str)
	{
		if($this->input->post('user_pswd2') == $this->input->post('user_pswd3'))
		{
			return true;
		}
		else
		{
			$this->form_validation->set_message('checkisthesame', ''.$this->lang->line('a0901').'');
			return false;
		}
	}

	// WORKING - used in $this->register()
	public function checkisthesame2($str)
	{
		if($this->input->post('user_password') == $this->input->post('user_password2'))
		{
			return true;
		}
		else
		{
			$this->form_validation->set_message('checkisthesame2', $this->lang->line('c140'));
			return false;
		}
	}

	// WORKING - used in $this->register()
	public function checkisthatemail($str)
	{
		$ResultDBUsers = $this->System_model->UserGetDataByEmail();

		$IsThatUser = false;

		foreach($ResultDBUsers->result() as $row) {
			$IsThatUser = true;
			//echo '{{{{{{{{{{{{{'.$row->user_id.'}}}}}}}}}}}}}}}}}}';
		}

		if(!$IsThatUser)
		{
			return true;
		}
		else
		{
			$this->form_validation->set_message('checkisthatemail', $this->lang->line('c141'));
			return false;
		}
	}

	// WORKING
	private function SendEmail($To,$Subject,$Body)
	{
		/*echo $Host.'-Host<br />';
		echo $Auth.'-Auth<br />';
		echo $UserName.'-UserName<br />';
		echo $Password.'-Password<br />';
		echo $SMTPSecure.'-Secure<br />';
		echo $Port.'-Port<br />';
		echo $From['email'].'-EmailFrom<br />';
		echo $To.'-EmailTo<br />';
		echo $Subject.'-Subject<br />';
		echo $Body.'-Body<br />';*/

		$ResultDB = $this->System_model->GetSystemConfig();

		foreach($ResultDB->result() as $row)
		{
			$ConfigTable[$row->config_name] = $row->config_value;
		}

		require 'library/PHPMailer/src/Exception.php';
		require 'library/PHPMailer/src/PHPMailer.php';
		require 'library/PHPMailer/src/SMTP.php';

		$mail = new PHPMailer;

		try {

			$mail->isSMTP();
			$mail->SMTPDebug = 0;
			$mail->Host = $this->config->item('send_email_stmp_host');
			$mail->SMTPAuth = true;
			$mail->Username = $this->config->item('send_email_stmp_username');
			$mail->Password = $this->config->item('send_email_stmp_password');

			if($this->config->item('send_email_tls') == 'tls') {$mail->SMTPSecure = 'tls';}

			$mail->Port = $this->config->item('send_email_stmp_port');

			//Recipients
			$From = array('email' => $this->config->item('send_email_user_name'), 'name' => $ConfigTable['title']);
			$mail->setFrom($From['email'],$From['name']);
			$mail->addAddress($To);

			// Attachments
			//$mail->addAttachment('/var/tmp/file.tar.gz');
			//$mail->addAttachment('/tmp/image.jpg', 'new.jpg');

			// Content
			$mail->CharSet = 'UTF-8';
			$mail->isHTML(false);
			$mail->Subject = $Subject;
			$mail->Body = $Body;

			if($mail->send())
			{
				$EmailWasSend = true;
			}
			else
			{
				$EmailWasSend = false;
			}

			/*$mail->Debugoutput = function($str, $level) {
				file_put_contents('smtp.log', gmdate('Y-m-d H:i:s'). "\t$level\t$str\n", FILE_APPEND | LOCK_EX);
			};*/
		}
		catch (Exception $e)
		{
			$EmailWasSend = false;
		}

		return $EmailWasSend;
	}

	// WORKING
	public function register()
	{
		if($this->input->post('formregister') == 'yes')
		{
			$this->form_validation->set_rules('user_email', ''.$this->lang->line('a0860').'', 'required|valid_email|callback_checkisthatemail');
			$this->form_validation->set_rules('user_password', ''.$this->lang->line('a0861').'', 'required|min_length[8]|max_length[20]');
			$this->form_validation->set_rules('user_password2', $this->lang->line('c142'), 'required|min_length[8]|max_length[20]|callback_checkisthesame2');

			if($this->form_validation->run() != FALSE)
			{
				$this->load->helper('string');
				$UserKey = strtolower(random_string('alnum', 20));

				$this->System_model->WriteLog($this->lang->line('c143').$this->input->post('user_email'));
				$this->System_model->UserRegister($UserKey);

				$ResultDB4 = $this->System_model->SelectEmailContent('register');

				foreach($ResultDB4->result() as $row4)
				{
					$ReadyTitle = $row4->email_title;
					$ReadyContent = $row4->email_content;
				}

				$ResultDBUser = $this->System_model->UserGetDataByEmailInput($this->input->post('user_email'));

				foreach($ResultDBUser->result() as $rowUser)
				{
					$UserIsId = $rowUser->user_id;
				}

				$ActivationLinkToAccount = base_url('activate/'.$UserIsId.'/'.$UserKey);

				$ReadyContent = str_replace('[activation_link]',$ActivationLinkToAccount,$ReadyContent);

				$DefUserDate = date('Y-m-d H:i:s');
				$DefUserIp = $_SERVER['REMOTE_ADDR'];

				$ReadyTitle = str_replace('[user_date]',$DefUserDate,$ReadyTitle);
				$ReadyTitle = str_replace('[user_ip]',$DefUserIp,$ReadyTitle);

				$ReadyContent = str_replace('[user_date]',$DefUserDate,$ReadyContent);
				$ReadyContent = str_replace('[user_ip]',$DefUserIp,$ReadyContent);

				$ResultSendEmail = $this->SendEmail($this->input->post('user_email'), $ReadyTitle, $ReadyContent);

				/*if($ResultSendEmail)
				{
					echo 'Wysłano';
				}
				else
				{
					echo 'Nie wysłano';
				}*/

				$SystemLang['UserRegistered'] = true;

				$SystemLang['Vuser_email'] = '';
			}
			else {
				$SystemLang['Vuser_email'] = $this->input->post('user_email');
			}
		}

		$SystemLang['Title'] = $this->lang->line('c144');
		$SystemLang['Content'] = $this->lang->line('c145');

		$this->load->view('head',$SystemLang);

		$this->load->view('register', $SystemLang);

		$this->load->view('foot');
	}

	// WORKING
	public function activateaccount($UserNumber,$UserKey)
	{
		$SystemLang['Title'] = $this->lang->line('c146');
		$SystemLang['Content'] = $this->lang->line('c147');

		$this->load->view('head',$SystemLang);

		$ActivationIsReady = $this->System_model->UserActivateAccount($UserNumber,$UserKey);

		if($ActivationIsReady)
		{
			$ResultDB = $this->System_model->GetUserDataById($UserNumber);
			foreach($ResultDB->result() as $row)
			{
				$UserEmail = $row->user_email;
			}

			$SystemLang['ActivateAccount'] = true;
			$this->System_model->WriteLog($this->lang->line('c148').$UserEmail);
		}
		else
		{
			$ResultDB = $this->System_model->GetUserDataById($UserNumber);
			foreach($ResultDB->result() as $row)
			{
				$UserEmail = $row->user_email;
			}

			$SystemLang['ActivateAccount'] = false;
			$this->System_model->WriteLog($this->lang->line('c149').$UserEmail);
		}

		$this->load->view('user/activate', $SystemLang);

		$this->load->view('foot');
	}

	// WORKING
	public function settingsofscript()
	{
		if($_SESSION['user_id'] == ""){redirect();exit();}
		if($_SESSION['user_admin'] != "y"){redirect();exit();}

		$SystemLang['Title'] = ''.$this->lang->line('a0866').'';
		$SystemLang['Content'] = ''.$this->lang->line('a0867').'';

		$this->load->view('head',$SystemLang);

		if($this->input->post('addpage') == 'yes')
		{
			$this->form_validation->set_rules('title', ''.$this->lang->line('a0868').'', 'required');
			$this->form_validation->set_rules('root_email', ''.$this->lang->line('a0869').'', 'required|valid_email');
			$this->form_validation->set_rules('keywords', $this->lang->line('c150'), 'required');
			$this->form_validation->set_rules('description', $this->lang->line('c151'), 'required');

			if($this->form_validation->run() != FALSE)
			{
				$this->System_model->WriteLog($this->lang->line('c152'));
				$this->System_model->UpdateConfig();

				$SystemLang['content_added'] = true;

				$this->System_model->WriteLog($this->lang->line('a0542'));
			}

			$SystemLang['Ctitle'] = $this->input->post('title');
			$SystemLang['Croot_email'] = $this->input->post('root_email');
			$SystemLang['Cdescription'] = $this->input->post('description');
			$SystemLang['Ckeywords'] = $this->input->post('keywords');
		}
		else
		{
			$ConfigTable = $this->System_model->GetConfig();
			$SystemLang['Ctitle'] = $ConfigTable['title'];
			$SystemLang['Croot_email'] = $ConfigTable['root_email'];
			$SystemLang['Cdescription'] = $ConfigTable['description'];
			$SystemLang['Ckeywords'] = $ConfigTable['keywords'];
		}

		$this->load->view('user/settings', $SystemLang);

		$this->load->view('foot');
	}

	// WORKING
	public function editemail()
	{
		if($_SESSION['user_id'] == ""){redirect();exit();}
		if($_SESSION['user_admin'] != "y"){redirect();exit();}

		$SystemLang['Title'] = ''.$this->lang->line('a0892').'';
		$SystemLang['Content'] = ''.$this->lang->line('a0893').'';

		$this->load->view('head',$SystemLang);

		if($this->input->post('formlogin') == 'yes')
		{
			$this->form_validation->set_rules('email_title1', ''.$this->lang->line('a0894').'', 'required');
			$this->form_validation->set_rules('email_title2', ''.$this->lang->line('a0894').'', 'required');
			$this->form_validation->set_rules('email_title3', ''.$this->lang->line('a0894').'', 'required');
			$this->form_validation->set_rules('email_content1', ''.$this->lang->line('a0895').'', 'required');
			$this->form_validation->set_rules('email_content2', ''.$this->lang->line('a0895').'', 'required');
			$this->form_validation->set_rules('email_content3', ''.$this->lang->line('a0895').'', 'required');

			if($this->form_validation->run() != FALSE)
			{
				$this->System_model->WriteLog($this->lang->line('c153'));
				$ResultDB = $this->System_model->UpdateEmails();

				$SystemLang['EmailUpdated'] = true;

			}

			$SystemLang['Femail_title1'] = $this->input->post('email_title1');
			$SystemLang['Femail_content1'] = $this->input->post('email_content1');
			$SystemLang['Femail_title2'] = $this->input->post('email_title2');
			$SystemLang['Femail_content2'] = $this->input->post('email_content2');
			$SystemLang['Femail_title3'] = $this->input->post('email_title3');
			$SystemLang['Femail_content3'] = $this->input->post('email_content3');

			$ResultDB = $this->System_model->SelectEmail('recpassword');
			foreach($ResultDB->result() as $row)
			{
				$SystemLang['Femail_desc1'] = $row->email_desc;
			}

			$ResultDB = $this->System_model->SelectEmail('newpass');
			foreach($ResultDB->result() as $row)
			{
				$SystemLang['Femail_desc2'] = $row->email_desc;
			}

			$ResultDB = $this->System_model->SelectEmail('report');
			foreach($ResultDB->result() as $row)
			{
				$SystemLang['Femail_desc3'] = $row->email_desc;
			}

		}
		else
		{
			$ResultDB = $this->System_model->SelectEmail('recpassword');
			foreach($ResultDB->result() as $row)
			{
				$SystemLang['Femail_title1'] = $row->email_title;
				$SystemLang['Femail_content1'] = $row->email_content;
				$SystemLang['Femail_desc1'] = $row->email_desc;
			}

			$ResultDB = $this->System_model->SelectEmail('newpass');
			foreach($ResultDB->result() as $row)
			{
				$SystemLang['Femail_title2'] = $row->email_title;
				$SystemLang['Femail_content2'] = $row->email_content;
				$SystemLang['Femail_desc2'] = $row->email_desc;
			}

			$ResultDB = $this->System_model->SelectEmail('register');
			foreach($ResultDB->result() as $row)
			{
				$SystemLang['Femail_title3'] = $row->email_title;
				$SystemLang['Femail_content3'] = $row->email_content;
				$SystemLang['Femail_desc3'] = $row->email_desc;
			}
		}

		$this->load->view('user/editemail', $SystemLang);

		$this->load->view('foot');
	}

	// WORKING
	public function showlogs($PageIs='')
	{
		if($_SESSION['user_id'] == ""){redirect();exit();}
		if($_SESSION['user_admin'] != "y"){redirect();exit();}

		$SystemLang['Title'] = $this->lang->line('c154');
		$SystemLang['Content'] = $this->lang->line('c155');

		$ResultDB = $this->System_model->SelectUserEmail();

		foreach($ResultDB->result() as $row)
		{
			$UserTable[$row->user_id] = $row->user_email;
		}

		$this->load->view('head',$SystemLang);

		if($PageIs == "")
		{
			$PageIs = 0;
		}

		$this->System_model->WriteLog($this->lang->line('c156'));

		$ResultDB = $this->System_model->LogsCount();

		foreach($ResultDB->result() as $row)
		{
			$HowManyRows = $row->HowMany;
		}

		$this->load->library('pagination');

		$config['base_url'] = base_url('/logs/');
		$config['total_rows'] = $HowManyRows;
		$config['per_page'] = 30;
		$config['first_link'] = '&lt;&lt;';
		$config['last_link'] = '&gt;&gt;';
		$config['next_link'] = '&gt;';
		$config['prev_link'] = '&lt;';
		$config['num_links'] = 5;
		$config['full_tag_open'] = $this->lang->line('b41');
		$config['uri_segment'] = 2;
		$config['full_tag_open'] = '<ul class="PaginationClass PaginationClassA PaginationClassB">';
		$config['full_tag_close'] = '</ul>';
		$config['prev_link'] = '&lt;';
		$config['prev_tag_open'] = '<li>';
		$config['prev_tag_close'] = '</li>';
		$config['next_link'] = '&gt;';
		$config['next_tag_open'] = '<li>';
		$config['next_tag_close'] = '</li>';
		$config['cur_tag_open'] = '<li class="current"><a href="#">';
		$config['cur_tag_close'] = '</a></li>';
		$config['num_tag_open'] = '<li>';
		$config['num_tag_close'] = '</li>';
		$config['first_tag_open'] = '<li>';
		$config['first_tag_close'] = '</li>';
		$config['last_tag_open'] = '<li>';
		$config['last_tag_close'] = '</li>';
		$config['first_link'] = '&lt;&lt;';
		$config['last_link'] = '&gt;&gt;';

		$this->pagination->initialize($config);

		if($PageIs == '')
		{
			$PageIs = 0;
		}

		$ResultDB = $this->System_model->LogsSelectLimit($PageIs);

		$SystemLang['ReadyContent'] = '<div class="row RowColor3">
          <div class="col-md-1">#</div>
          <div class="col-md-2">'.$this->lang->line('b65').'</div>
          <div class="col-md-5">'.$this->lang->line('b66').'</div>
          <div class="col-md-2">'.$this->lang->line('b67').'</div>
          <div class="col-md-2">'.$this->lang->line('b68').'</div>
          </div>';

		foreach($ResultDB->result() as $row)
		{
			if($RowColor == 0)
			{
				$RowColor = 1;
				$RowStyle = 'RowColor1';
			}
			else
			{
				$RowColor = 0;
				$RowStyle = 'RowColor2';
			}

			if($row->log_user_id != 0)
			{
				$UserWas = '<a href="'.base_url('userdetails/'.$row->log_user_id).'">'.$UserTable[$row->log_user_id].'</a>';
			}
			else
			{
				$UserWas = '<em>brak</em>';
			}

			$SystemLang['ReadyContent'] .= '<div class="row '.$RowStyle.'">';

			$SystemLang['ReadyContent'] .= '
            <div class="col-md-1">'.$row->log_id.'</div>
            <div class="col-md-2">'.$UserWas.'</div>
            <div class="col-md-5">'.$row->log_what.'</div>
            <div class="col-md-2">'.$row->log_time.'</div>
            <div class="col-md-2">'.$row->log_ip.'</div>
            
            ';

			$SystemLang['ReadyContent'] .= '</div>';
		}

		$this->load->view('user/showlogs', $SystemLang);

		$this->load->view('foot');
	}

	// WORKING
	public function showusers($PageIs='')
	{
		if($_SESSION['user_id'] == ""){redirect();exit();}
		if($_SESSION['user_admin'] != "y"){redirect();exit();}

		$SystemLang['Title'] = $this->lang->line('c157');
		$SystemLang['Content'] = $this->lang->line('c158');

		$this->load->view('head',$SystemLang);

		if($PageIs == "")
		{
			$PageIs = 0;
		}

		$this->System_model->WriteLog($this->lang->line('c159'));

		$ResultDB = $this->System_model->UsersCount();

		foreach($ResultDB->result() as $row)
		{
			$HowManyRows = $row->HowMany;
		}

		$this->load->library('pagination');

		$config['base_url'] = base_url('/users/');
		$config['total_rows'] = $HowManyRows;
		$config['per_page'] = 30;
		$config['first_link'] = '&lt;&lt;';
		$config['last_link'] = '&gt;&gt;';
		$config['next_link'] = '&gt;';
		$config['prev_link'] = '&lt;';
		$config['num_links'] = 5;
		$config['full_tag_open'] = $this->lang->line('b41');
		$config['uri_segment'] = 2;
		$config['full_tag_open'] = '<ul class="PaginationClass PaginationClassA PaginationClassB">';
		$config['full_tag_close'] = '</ul>';
		$config['prev_link'] = '&lt;';
		$config['prev_tag_open'] = '<li>';
		$config['prev_tag_close'] = '</li>';
		$config['next_link'] = '&gt;';
		$config['next_tag_open'] = '<li>';
		$config['next_tag_close'] = '</li>';
		$config['cur_tag_open'] = '<li class="current"><a href="#">';
		$config['cur_tag_close'] = '</a></li>';
		$config['num_tag_open'] = '<li>';
		$config['num_tag_close'] = '</li>';
		$config['first_tag_open'] = '<li>';
		$config['first_tag_close'] = '</li>';
		$config['last_tag_open'] = '<li>';
		$config['last_tag_close'] = '</li>';
		$config['first_link'] = '&lt;&lt;';
		$config['last_link'] = '&gt;&gt;';

		$this->pagination->initialize($config);

		if($PageIs == '')
		{
			$PageIs = 0;
		}

		$ResultDB = $this->System_model->UsersSelectLimit($PageIs);

		$SystemLang['ReadyContent'] = '<div class="row RowColor3">
          <div class="col-md-1">#</div>
          <div class="col-md-4">'.$this->lang->line('b72').'</div>
          <div class="col-md-2">'.$this->lang->line('b73').'</div>
          <div class="col-md-2" style="text-align: center;">'.$this->lang->line('b74').'</div>
          <div class="col-md-2" style="text-align: center;">'.$this->lang->line('b75').'</div>
          <div class="col-md-1">'.$this->lang->line('b76').'</div>
          </div>';

		foreach($ResultDB->result() as $row)
		{
			if($RowColor == 0)
			{
				$RowColor = 1;
				$RowStyle = 'RowColor1';
			}
			else
			{
				$RowColor = 0;
				$RowStyle = 'RowColor2';
			}

			if($row->user_active == 'y')
			{
				$UserActive = '<span class="alert-success btn-sm">'.$this->lang->line('b77').'</span>';
			}
			else
			{
				$UserActive = '<span class="alert-danger btn-sm">'.$this->lang->line('b78').'</span>';
			}

			if($row->user_admin == 'y')
			{
				$UserRoot = '<span class="alert-success btn-sm">'.$this->lang->line('b77').'</span>';
			}
			else
			{
				$UserRoot = '<span class="alert-warning btn-sm">'.$this->lang->line('b78').'</span>';
			}

			$SystemLang['ReadyContent'] .= '<div class="row '.$RowStyle.'">';

			$SystemLang['ReadyContent'] .= '
            <div class="col-md-1">'.$row->user_id.'</div>
            <div class="col-md-4"><a href="'.base_url('userdetails/'.$row->user_id).'">'.$row->user_email.'</a></div>
            <div class="col-md-2">'.$row->user_register.'</div>
            <div class="col-md-2" style="text-align: center;">'.$UserActive.'</div>
            <div class="col-md-2" style="text-align: center;">'.$UserRoot.'</div>
            <div class="col-md-1"><a href="'.base_url('userdetails/'.$row->user_id).'" title="'.$this->lang->line('b79').'" class="btn btn-success btn-sm">'.$this->lang->line('b79').'</a></div>
            
            ';

			$SystemLang['ReadyContent'] .= '</div>';
		}

		$this->load->view('user/showusers', $SystemLang);

		$this->load->view('foot');
	}

	// WORKING
	public function showuserdetails($UserId)
	{
		if($_SESSION['user_id'] == ""){redirect();exit();}
		if($_SESSION['user_admin'] != "y"){redirect();exit();}

		$SystemLang['Title'] = $this->lang->line('b80');
		$SystemLang['Content'] = $this->lang->line('b81');

		$this->load->view('head',$SystemLang);

		$this->System_model->WriteLog($this->lang->line('c160'));

		if($this->input->get('privilages') == 'yes')
		{
			$this->System_model->WriteLog($this->lang->line('c161'));

			$this->System_model->UsersChangePrivilage($UserId);
			$SystemLang['PrivilagesChanged'] = true;

			$this->System_model->WriteLog($this->lang->line('b82'));
		}

		$SystemLang['IdOfContent'] = $UserId;

		$this->load->view('user/showuserdetails', $SystemLang);

		$this->load->view('foot');
	}

	// WORKING
    public function usedcomponents()
    {
        //if($_SESSION['user_id'] == ""){redirect();exit();}
        
        $SystemLang['Title'] = ''.$this->lang->line('a1069').'';
        $SystemLang['Content'] = ''.$this->lang->line('a1070').'';
        
        $this->load->view('head',$SystemLang);
        
        $this->load->view('components', $SystemLang);
            
        $this->load->view('foot');
    }

    // WORKING
    public function about()
    {
        //if($_SESSION['user_id'] == ""){redirect();exit();}
        
        $SystemLang['Title'] = ''.$this->lang->line('a1090').'';
        $SystemLang['Content'] = ''.$this->lang->line('a1091').'';
        
        $this->load->view('head',$SystemLang);
        
        $this->load->view('about', $SystemLang);
            
        $this->load->view('foot');
    }

    // WORKING
    public function logout()
    {
        $_SESSION['user_id'] = '';
        $_SESSION['user_email'] = '';
	    $_SESSION['user_admin'] = '';

        redirect();
    }

    // WORKING
    public function error404()
    {
	    $SystemLang['Title'] = $this->lang->line('c162');
	    $SystemLang['Content'] = $this->lang->line('c163');

	    $this->load->view('head',$SystemLang);

	    $this->load->view('error404', $SystemLang);

	    $this->load->view('foot');
    }
}

?>