<?php

if ( ! defined('BASEPATH')) exit('No direct script access allowed');

/**
 * @author: Lucas Sosna
 * @copyright: 2019
 * @e-mail: tree@interia.pl
 * @e-mail: support@phpbluedragon.eu
 * @www: http://phpbluedragon.eu
 */

class System_model extends CI_Model 
{
    public function __construct()
    {
        parent::__construct();
    }
    
    public function UserCheckEmail($Email)
    {
        $Email = htmlspecialchars($Email);
        
        $QueryResult = $this->db->query('SELECT count(user_email) AS HowMany FROM 
		{PREFIXDB}user
        WHERE
        user_email = "'.$this->db->escape_str($Email).'"
		');
        		
		return $QueryResult;
    }
    
    public function ChangePasswordAutomat($UserId,$TemporaryPassword)
    {
        /*
        user_password_clear = "'.$this->db->escape_str($TemporaryPassword).'"
        */
        
        $UserId = htmlspecialchars($UserId);
        $TemporaryPassword = htmlspecialchars($TemporaryPassword);
        
        $SaltPassword = password_hash($TemporaryPassword, PASSWORD_DEFAULT);
        
        $QueryResult = $this->db->query('UPDATE 
        {PREFIXDB}user
        SET
        user_password = "'.$this->db->escape_str($SaltPassword).'"
        WHERE
        user_id = "'.$this->db->escape_str($UserId).'"
        ');
        
    }
    
    public function CheckKeyPasswords($UserId,$KeyPassword,$KeyPassword2)
    {
        $UserId = htmlspecialchars($UserId);
        $KeyPassword = htmlspecialchars($KeyPassword);
        $KeyPassword2 = htmlspecialchars($KeyPassword2);
        
        $QueryResult = $this->db->query('SELECT count(password_id) As HowMany FROM 
        {PREFIXDB}password 
        WHERE
        password_user_id = "'.$this->db->escape_str($UserId).'"
        AND
        password_hash1 = "'.$this->db->escape_str($KeyPassword).'"
        AND
        password_hash2 = "'.$this->db->escape_str($KeyPassword2).'"
        AND
        password_time > "'.$this->db->escape_str(date('Y-m-d H:i:s')).'"
        AND
        password_used = ""
        ');
        
        $this->db->query('UPDATE 
        {PREFIXDB}password 
        SET
        password_used = "y"
        WHERE
        password_user_id = "'.$this->db->escape_str($UserId).'"
        AND
        password_hash1 = "'.$this->db->escape_str($KeyPassword).'"
        AND
        password_hash2 = "'.$this->db->escape_str($KeyPassword2).'"
        AND
        password_time > "'.$this->db->escape_str(date('Y-m-d H:i:s')).'"
        ');
        
        return $QueryResult;
    }
    
    public function GenerateNewPassword($UserId,$KeyPassword,$KeyPassword2)
    {
        $UserId = htmlspecialchars($UserId);
        $KeyPassword = htmlspecialchars($KeyPassword);
        $KeyPassword2 = htmlspecialchars($KeyPassword2);
        
        $QueryResult = $this->db->query('INSERT INTO 
        {PREFIXDB}password
        (
        password_user_id,
        password_hash1,
        password_hash2,
        password_time,
        password_ip
        )
        VALUES
        (
        "'.$this->db->escape_str($UserId).'",
        "'.$this->db->escape_str($KeyPassword).'",
        "'.$this->db->escape_str($KeyPassword2).'",
        "'.$this->db->escape_str(date("Y-m-d H:i:s",time()+2*60*60)).'",
        "'.$this->db->escape_str($_SERVER['REMOTE_ADDR']).'"
        )
        ');
    }
    
    public function SelectGenerateNewPassword($UserId,$KeyPassword,$KeyPassword2)
    {
        $UserId = htmlspecialchars($UserId);
        $KeyPassword = htmlspecialchars($KeyPassword);
        $KeyPassword2 = htmlspecialchars($KeyPassword2);
        
        $QueryResult = $this->db->query('SELECT * FROM 
		{PREFIXDB}password
        WHERE
        password_user_id = "'.$this->db->escape_str($UserId).'"
        AND
        password_hash1 = "'.$this->db->escape_str($KeyPassword).'"
        AND
        password_hash2 = "'.$this->db->escape_str($KeyPassword2).'"
		');
        		
		return $QueryResult;
    }
    
    public function UserCheckEmailSelect($Email)
    {
        $Email = htmlspecialchars($Email);
        
        $QueryResult = $this->db->query('SELECT * FROM 
		{PREFIXDB}user
        WHERE
        user_email = "'.$this->db->escape_str($Email).'"
		');
        		
		return $QueryResult;
    }
    
    public function UserGetData()
    {
        $QueryResult = $this->db->query('SELECT * FROM 
		{PREFIXDB}user
        WHERE
        user_id = "'.$this->db->escape_str($_SESSION['user_id']).'"
		');
        		
		return $QueryResult;
    }

	public function UserGetDataByEmail()
	{
		$QueryResult = $this->db->query('SELECT * FROM 
		{PREFIXDB}user
        WHERE
        user_email = "'.$this->db->escape_str($this->input->post('user_email')).'"
		');

		return $QueryResult;
	}

	public function UserGetDataByEmailInput($Email)
	{
		$QueryResult = $this->db->query('SELECT * FROM 
		{PREFIXDB}user
        WHERE
        user_email = "'.$this->db->escape_str($Email).'"
		');

		return $QueryResult;
	}

	public function UserRegister($UserKey)
	{
		$SaltPassword = password_hash($this->input->post('user_password'), PASSWORD_DEFAULT);
		$SaltPassword = htmlspecialchars($SaltPassword);

		$QueryResult = $this->db->query('INSERT INTO 
        {PREFIXDB}user
        (
        user_email,
        user_password,
        user_key,
        user_register,
        user_register_ip
        )
        VALUES
        (
        "' . $this->db->escape_str($this->input->post('user_email')) . '",
        "' . $this->db->escape_str($SaltPassword) . '",
        "' . $this->db->escape_str($UserKey) . '",
        "' . $this->db->escape_str(date('Y-m-d H:i:s')) . '",
        "' . $this->db->escape_str($_SERVER['REMOTE_ADDR']) . '"
        )
        ');
	}

    public function UpdateUserPswd()
    {
        $SaltPassword = password_hash($this->input->post('user_pswd2'), PASSWORD_DEFAULT);
        $SaltPassword = htmlspecialchars($SaltPassword);
        
        $QueryResult = $this->db->query('UPDATE 
        {PREFIXDB}user
        SET
        user_password = "'.$this->db->escape_str($SaltPassword).'"
        WHERE
        user_id = "'.$this->db->escape_str($_SESSION['user_id']).'"
        ');
    }
    
    public function CheckUser()
    {
        $Email = htmlspecialchars($this->input->post('user_email'));
        
        $QueryResult = $this->db->query('SELECT * FROM 
		{PREFIXDB}user
        WHERE
        user_email = "'.$this->db->escape_str($Email).'"
		');
        
        foreach($QueryResult->result() as $row)
		{
            $PasswordToVerify = $row->user_password;
            $UserId = $row->user_id;
            $UserEmail = $row->user_email;
			$UserActive = $row->user_active;
			$UserAdmin = $row->user_admin;
        }

        if($UserActive != 'y')
        {
	        $TableUser['IsAuth'] = 'noactiveaccount';
        }
        elseif(password_verify($this->input->post('user_password'), $PasswordToVerify) == false)
        {
            $TableUser['IsAuth'] = 'no';
        }
        else
        {
            $TableUser['IsAuth'] = 'yes';
            $TableUser['UserId'] = $UserId;
            $TableUser['UserEmail'] = $UserEmail;
	        $TableUser['UserAdmin'] = $UserAdmin;
        }
        
        return $TableUser;
    }
    
    public function GetUserData($Email)
    {
        $Email = htmlspecialchars($Email);
        
        $QueryResult = $this->db->query('SELECT * FROM 
		{PREFIXDB}user
        WHERE
        user_email = "'.$this->db->escape_str($Email).'"
		');
        		
		return $QueryResult;
    }
    
    public function GetUserDataById($Id)
    {
        $Id = htmlspecialchars($Id);
        
        $QueryResult = $this->db->query('SELECT * FROM 
		{PREFIXDB}user
        WHERE
        user_id = "'.$this->db->escape_str($Id).'"
		');
        		
		return $QueryResult;
    }
    
    public function GetUserDataByDate($Id)
    {
        $Id = htmlspecialchars($Id);
        
        $QueryResult = $this->db->query('SELECT * FROM 
		{PREFIXDB}user
        WHERE
        user_id = "'.$this->db->escape_str($Id).'"
        AND
        user_package_date > "'.$this->db->escape_str(date('Y-m-d H:i:s')).'"
		');
        		
		return $QueryResult;
    }    
    
    public function WriteLog($Message)
    {
        $Message = htmlspecialchars($Message);
        
        $QueryResult = $this->db->query('INSERT INTO 
        {PREFIXDB}log
        (
        log_user_id,
        log_what,
        log_time,
        log_ip
        )
        VALUES
        (
        "'.$this->db->escape_str($_SESSION['user_id']).'",
        "'.$this->db->escape_str($Message).'",
        "'.$this->db->escape_str(date('Y-m-d H:i:s')).'",
        "'.$this->db->escape_str($_SERVER['REMOTE_ADDR']).'"
        )
        ');
    }

	public function SelectUserEmail()
	{
		$QueryResult = $this->db->query('SELECT user_id,user_email FROM 
		{PREFIXDB}user
        ');

		return $QueryResult;
	}

    public function LogsCount()
    {
	    $QueryResult = $this->db->query('SELECT count(log_id) AS HowMany FROM 
		{PREFIXDB}log
		');

	    return $QueryResult;
    }

	public function LogsSelectLimit($Page)
	{
		if($Page == "")
		{
			$Page = 0;
		}

		if(!is_numeric($Page)){exit();}

		$QueryResult = $this->db->query('SELECT * FROM 
		{PREFIXDB}log
        ORDER BY
        log_id DESC
        LIMIT '.$Page.',30
		');

		return $QueryResult;
	}

	public function UsersCount()
	{
		$QueryResult = $this->db->query('SELECT count(user_id) AS HowMany FROM 
        {PREFIXDB}user 
        ');

		return $QueryResult;
	}

	public function UsersSelectLimit($Page='')
	{
		if($Page == "")
		{
			$Page = 0;
		}

		if(!is_numeric($Page)){exit();}

		$QueryResult = $this->db->query('SELECT * FROM 
        {PREFIXDB}user 
        ORDER BY user_id ASC
        LIMIT '.$Page.',30
        ');

		return $QueryResult;
	}

	public function UserSelectData($UserId)
	{
		$QueryResult = $this->db->query('SELECT * FROM 
        {PREFIXDB}user 
        WHERE
        user_id = "'.$this->db->escape_str($UserId).'"
        ');

		return $QueryResult;
	}

	public function UsersChangePrivilage($UserId)
	{
		$QueryResult = $this->db->query('SELECT * FROM 
        {PREFIXDB}user 
        WHERE
        user_id = "'.$this->db->escape_str($UserId).'"
        ');

		foreach($QueryResult->result() as $row)
		{
			$ValueOfConfig = $row->user_admin;
		}

		if($ValueOfConfig == 'y')
		{
			$QueryResult = $this->db->query('UPDATE {PREFIXDB}user SET user_admin = "" WHERE user_id = "'.$this->db->escape_str($UserId).'"');
		}
		else
		{
			$QueryResult = $this->db->query('UPDATE {PREFIXDB}user SET user_admin = "y" WHERE user_id = "'.$this->db->escape_str($UserId).'"');
		}
	}

	public function UserActivateAccount($UserNumber,$UserKey)
	{
		$QueryResult = $this->db->query('SELECT * FROM 
        {PREFIXDB}user 
        WHERE
        user_id = "'.$this->db->escape_str($UserNumber).'"
        AND
        user_key = "'.$this->db->escape_str($UserKey).'"
        AND
        user_active != "y"
        ');

		foreach($QueryResult->result() as $rowUser)
		{
			$IsThatUser = true;
		}

		if($IsThatUser)
		{
			$QueryResult = $this->db->query('UPDATE 
	        {PREFIXDB}user 
	        SET
	        user_active = "y",
	        user_activated = "'.$this->db->escape_str(date('Y-m-d H:i:s')).'",
	        user_activated_ip = "'.$this->db->escape_str($_SERVER['REMOTE_ADDR']).'"
	        WHERE
	        user_key = "'.$this->db->escape_str($UserKey).'"
	        AND
	        user_id = "'.$this->db->escape_str($UserNumber).'"
	        ');

			$ToReturn = true;
		}
		else
		{
			$ToReturn = false;
		}

		return $ToReturn;
	}

    public function GetSystemConfig()
    {
        $QueryResult = $this->db->query('SELECT * FROM 
        {PREFIXDB}config
        ');
        
        return $QueryResult;
    }
    
    public function UpdateEmails()
    {    
        $EmailTitle1 = htmlspecialchars($this->input->post('email_title1'));
        $EmailContent1 = htmlspecialchars($this->input->post('email_content1'));

        $QueryResult = $this->db->query('UPDATE 
        {PREFIXDB}email
        SET
        email_title = "'.$this->db->escape_str($EmailTitle1).'",
        email_content = "'.$this->db->escape_str($EmailContent1).'"
        WHERE
        email_what = "recpassword"
        ');
        
        $EmailTitle2 = htmlspecialchars($this->input->post('email_title2'));
        $EmailContent2 = htmlspecialchars($this->input->post('email_content2'));

        $QueryResult = $this->db->query('UPDATE 
        {PREFIXDB}email
        SET
        email_title = "'.$this->db->escape_str($EmailTitle2).'",
        email_content = "'.$this->db->escape_str($EmailContent2).'"
        WHERE
        email_what = "newpass"
        ');
        
        $EmailTitle3 = htmlspecialchars($this->input->post('email_title3'));
        $EmailContent3 = htmlspecialchars($this->input->post('email_content3'));

        $QueryResult = $this->db->query('UPDATE 
        {PREFIXDB}email
        SET
        email_title = "'.$this->db->escape_str($EmailTitle3).'",
        email_content = "'.$this->db->escape_str($EmailContent3).'"
        WHERE
        email_what = "report"
        ');
    }
    
    public function SelectEmail($Name)
    {
        $QueryResult = $this->db->query('SELECT * FROM 
        {PREFIXDB}email 
        WHERE
        email_what = "'.$this->db->escape_str($Name).'"
        ');
        
        return $QueryResult;
    }
    
    public function GetConfig()
    {
        $ResultDB = $this->System_model->GetSystemConfig();
    
    	foreach($ResultDB->result() as $row)
    	{
    		$ConfigTable[$row->config_name] = $row->config_value;
    	}
        
        return $ConfigTable;
    }

    public function SelectEmailContent($WhatEmail)
    {
        $QueryResult = $this->db->query('SELECT * FROM 
		{PREFIXDB}email
        WHERE
        email_what = "'.$this->db->escape_str($WhatEmail).'"
		');

        return $QueryResult;
    }

	public function UpdateConfig()
	{
		$QueryResult = $this->db->query('UPDATE {PREFIXDB}config SET config_value = "'.$this->db->escape_str($this->input->post('title')).'" WHERE config_name = "title"');
		$QueryResult = $this->db->query('UPDATE {PREFIXDB}config SET config_value = "'.$this->db->escape_str($this->input->post('root_email')).'" WHERE config_name = "root_email"');
		$QueryResult = $this->db->query('UPDATE {PREFIXDB}config SET config_value = "'.$this->db->escape_str($this->input->post('description')).'" WHERE config_name = "description"');
		$QueryResult = $this->db->query('UPDATE {PREFIXDB}config SET config_value = "'.$this->db->escape_str($this->input->post('keywords')).'" WHERE config_name = "keywords"');
	}

    // Categories

    public function SelectCategoryList()
    {
        $QueryResult = $this->db->query('SELECT * FROM 
		{PREFIXDB}category
        WHERE
        category_user_id = "'.$this->db->escape_str($_SESSION['user_id']).'"
		');

        return $QueryResult;
    }

    public function SelectOneCategoryById($CategoryId)
    {
        $QueryResult = $this->db->query('SELECT * FROM 
		{PREFIXDB}category
        WHERE
        category_id = "'.$this->db->escape_str($CategoryId).'"
        AND
        category_user_id = "'.$this->db->escape_str($_SESSION['user_id']).'"
		');

        return $QueryResult;
    }

    public function SelectCategoryContent($CategoryId)
    {
        if($CategoryId == 1)
        {
            // 1 - My Day
            $QueryResult = $this->db->query('SELECT * FROM 
            {PREFIXDB}todo
            WHERE
            todo_planned = "y"
            AND
            todo_planned_date = "' . $this->db->escape_str(date('Y-m-d')) . '"
            AND
            todo_trash = "n"
            AND
            todo_user_id = "' . $this->db->escape_str($_SESSION['user_id']) . '"
            ');
        }
        elseif($CategoryId == 2)
        {
            // 2 - Important
            $QueryResult = $this->db->query('SELECT * FROM 
            {PREFIXDB}todo
            WHERE
            todo_important = "y"
            AND
            todo_trash = "n"
            AND
            todo_user_id = "' . $this->db->escape_str($_SESSION['user_id']) . '"
            ');
        }
        elseif($CategoryId == 3)
        {
            // 3 - Planned
            $QueryResult = $this->db->query('SELECT * FROM 
            {PREFIXDB}todo
            WHERE
            todo_planned = "y"
            AND
            todo_trash = "n"
            AND
            todo_user_id = "' . $this->db->escape_str($_SESSION['user_id']) . '"
            ');
        }
        elseif($CategoryId == 5)
        {
            // 5 - Trash
            $QueryResult = $this->db->query('SELECT * FROM 
            {PREFIXDB}todo
            WHERE
            todo_trash = "y"
            AND
            todo_user_id = "' . $this->db->escape_str($_SESSION['user_id']) . '"
            ORDER BY 
            todo_planned_date ASC
            ');
        }
        else
        {
            // 4 - Tasks and others categories
            $QueryResult = $this->db->query('SELECT * FROM 
            {PREFIXDB}todo
            WHERE
            todo_category = "' . $this->db->escape_str($CategoryId) . '"
            AND
            todo_trash = "n"
            AND
            todo_user_id = "' . $this->db->escape_str($_SESSION['user_id']) . '"
            ');
        }

        return $QueryResult;
    }

    public function CategoryDelete($CategoryId)
    {
        if($CategoryId >= 6)
        {
            $QueryResult = $this->db->query('DELETE FROM 
            {PREFIXDB}category
            WHERE
            category_id = "' . $this->db->escape_str($CategoryId) . '"
            AND
            category_user_id = "' . $this->db->escape_str($_SESSION['user_id']) . '"
            ');

            $QueryResult = $this->db->query('UPDATE 
            {PREFIXDB}todo
            SET
            todo_category = "5",
            todo_trash = "y"
            WHERE
            todo_category = "' . $this->db->escape_str($CategoryId) . '"
            AND
            todo_user_id = "' . $this->db->escape_str($_SESSION['user_id']) . '"
            ');
        }
    }

    public function CategoryEdit($CategoryId,$CategoryName)
    {
        $QueryResult = $this->db->query('UPDATE 
        {PREFIXDB}category
        SET
        category_name = "' . $this->db->escape_str($CategoryName) . '"
        WHERE
        category_id = "' . $this->db->escape_str($CategoryId) . '"
        AND
        category_user_id = "' . $this->db->escape_str($_SESSION['user_id']) . '"
        ');
    }

    public function CategoryAdd($CategoryName)
    {
        $QueryResult = $this->db->query('INSERT INTO 
        {PREFIXDB}category
        (category_name,category_user_id)
        VALUES
        ("'. $this->db->escape_str($CategoryName) . '", "' . $this->db->escape_str($_SESSION['user_id']) . '")
        ');
    }

    // ToDos

	public function ToDoDeleteTrash()
	{
		$QueryResult = $this->db->query('DELETE FROM 
        {PREFIXDB}todo
        WHERE
        todo_trash = "y"
        AND
        todo_user_id = "' . $this->db->escape_str($_SESSION['user_id']) . '"
        ');
	}

	public function ToDoDeleteItem($ItemId)
	{
		$QueryResult = $this->db->query('UPDATE 
        {PREFIXDB}todo
        SET
        todo_trash = "y"
        WHERE
        todo_id = "' . $this->db->escape_str($ItemId) . '"
        AND
        todo_user_id = "' . $this->db->escape_str($_SESSION['user_id']) . '"
        ');
	}

	public function ToDoAdd()
	{
		if($this->input->post('todo_planned') == 'y')
		{
			$ToDoPlanned = 'y';
		}
		else
		{
			$ToDoPlanned = 'n';
		}

		$ToDoTrash = 'n';

		if(is_numeric($this->input->post('todo_category')))
		{
			$ToDoCategory = $this->input->post('todo_category');
		}
		else
		{
			exit;
		}

		if($this->input->post('todo_important') == 'y')
		{
			$ToDoImportant = 'y';
		}
		else
		{
			$ToDoImportant = 'n';
		}

		if (preg_match("/^[0-9]{4}-(0[1-9]|1[0-2])-(0[1-9]|[1-2][0-9]|3[0-1])$/",$this->input->post('todo_planned_date')))
		{
			$ToDoDate = $this->input->post('todo_planned_date');
		}
		else
		{
			$ToDoDate = date('Y-m-d');
		}

		$QueryResult = $this->db->query('INSERT INTO 
        {PREFIXDB}todo
        (
        todo_desc,
        todo_planned,
        todo_planned_date,
        todo_important,
        todo_category,
        todo_user_id,
        todo_trash
        )
        VALUES
        (
        "' . $this->db->escape_str($this->input->post('todo_desc')) . '", 
        "' . $this->db->escape_str($ToDoPlanned) . '",
        "' . $this->db->escape_str($ToDoDate) . '",
        "' . $this->db->escape_str($ToDoImportant) . '",
        "' . $this->db->escape_str($ToDoCategory) . '",
        "' . $this->db->escape_str($_SESSION['user_id']) . '",
        "' . $this->db->escape_str($ToDoTrash) . '"
        )
        ');
	}

	public function ToDoEdit($ItemId)
	{
		if($this->input->post('todo_planned') == 'y')
		{
			$ToDoPlanned = 'y';
		}
		else
		{
			$ToDoPlanned = 'n';
		}

		$ToDoTrash = 'n';

		if(is_numeric($this->input->post('todo_category')))
		{
			$ToDoCategory = $this->input->post('todo_category');
		}
		else
		{
			exit;
		}

		if($this->input->post('todo_important') == 'y')
		{
			$ToDoImportant = 'y';
		}
		else
		{
			$ToDoImportant = 'n';
		}

		if (preg_match("/^[0-9]{4}-(0[1-9]|1[0-2])-(0[1-9]|[1-2][0-9]|3[0-1])$/",$this->input->post('todo_planned_date')))
		{
			$ToDoDate = $this->input->post('todo_planned_date');
		}
		else
		{
			$ToDoDate = date('Y-m-d');
		}

		$QueryResult = $this->db->query('UPDATE 
        {PREFIXDB}todo
        SET
        todo_desc = "' . $this->db->escape_str($this->input->post('todo_desc')) . '", 
        todo_planned = "' . $this->db->escape_str($ToDoPlanned) . '",
        todo_planned_date = "' . $this->db->escape_str($ToDoDate) . '",
        todo_important = "' . $this->db->escape_str($ToDoImportant) . '",
        todo_category = "' . $this->db->escape_str($ToDoCategory) . '",
        todo_trash = "' . $this->db->escape_str($ToDoTrash) . '"
		WHERE
		todo_id = "' . $this->db->escape_str($ItemId) . '"
		AND
		todo_user_id = "' . $this->db->escape_str($_SESSION['user_id']) . '"
        ');
	}

	public function SelectOneToDoById($ItemId)
	{
		$QueryResult = $this->db->query('SELECT * FROM 
		{PREFIXDB}todo
        WHERE
        todo_id = "'.$this->db->escape_str($ItemId).'"
        AND
        todo_user_id = "'.$this->db->escape_str($_SESSION['user_id']).'"
		');

		return $QueryResult;
	}
}

?>